/* 
 * Based on f2a by Ulrich Hecht <uli@emulinks.de>
 * if2a patch by D. Gauchard <deyv@free.fr>
 * F2A Ultra support by Vincent Rubiolo <vincent.rubiolo@free.fr>
 * Licensed under the terms of the GNU Public License version 2
 */
 
// USB-related header
#ifndef __F2AUSB_H__
#define __F2AUSB_H__
#include "topheader.h"
#include <usb.h>

/* 
 * USB timeouts. f2a_usb_timeout as globlal so that the routines can tweak it
 * depending on their needs
 * Default value is USB_TIMEOUT
 */
#define USB_TIMEOUT			8000
extern int f2a_usb_timeout;

int	f2a_need_usb_reset 		(int verbosity);
int	f2a_fxload 			(char* bus, char* dev);
int 	f2a_ezusb2131_load 		(int f);
int 	f2a_usb_connect_root		(void);
int 	f2a_usb_connect 		(void);
void 	f2a_usb_disconnect 		(void);
void 	f2a_usb_exit 			(int status);
int 	f2a_usb_read 			(char *buffer, int buffer_size);
int 	f2a_usb_write			(char *buffer, int buffer_size);
int 	f2a_usb_write_by_block 		(char* buffer, int buffer_size, int block_size);

/* Hack to avoid creating a header to fxload.c, sth which is not our job to 
 * maintain
 */
int	ezusb_load_ram			(int fd);

#endif // __F2AUSB_H__
