/* 
 * Based on f2a by Ulrich Hecht <uli@emulinks.de>
 * if2a patch by D. Gauchard <deyv@free.fr>
 * F2A Ultra support by Vincent Rubiolo <vincent.rubiolo@free.fr>
 * Licensed under the terms of the GNU Public License version 2
 */
 
// Useful functions header
#ifndef __F2AUTILS_H__
#define __F2AUTILS_H__

#include "topheader.h"

extern int f2a_verbose;

int         	f2a_crc32(const char *str, int *crc32buf, int size);
int 		select_loader_pro (char* name);
int 		select_loader_ultra (char* name);
int 		select_firmware (char* name);
int 		select_multiboot (char* name);
int 		select_splash (char* name);
void 		f2a_init (void);
void 		f2a_exit (int status);
int 		f2a_connect (void);
void 		print_array(const char* array, int size);
void 		print_array_dual(const char* array, int size);
char* 		load_from_file(const char* filename, char* buffer, int* size);
int 		buffer_from_file(const char* filename, char* buffer, int size_to_check);
char* 		download_from_file(const char* filename, int* size);
int 		buffer_to_file(const char* filename, char* buffer, int size_to_write);

u_int16_t	ntoh16 (u_int16_t x);
u_int16_t	hton16 (u_int16_t x);
u_int32_t	ntoh32 (u_int32_t x);
u_int32_t	hton32 (u_int32_t x);

void 		regular_print (const char* format, ...);
void 		regular_printerr (const char* format, ...);
void 		printerrno (const char* format, ...);

#endif // __F2AUTILS_H__
